diff -Naur src.pgsql/backend/access/bitmap/bitmaputil.c src.bizgres/backend/access/bitmap/bitmaputil.c
--- src.pgsql/backend/access/bitmap/bitmaputil.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/bitmaputil.c	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,964 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmaputil.c
+ *	  Utility routines for on-disk bitmap index access method.
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL$
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/bitmap.h"
+#include "access/reloptions.h"
+#include "miscadmin.h"
+
+static void
+_bitmap_findnextword(BMBatchWords* words, uint32 nextReadNo);
+static void
+_bitmap_resetWord(BMBatchWords *words, uint32 prevStartNo);
+static uint8 _bitmap_find_bitset(BM_HRL_WORD word, uint8 lastPos);
+
+/*
+ * _bitmap_formitem() -- construct a LOV entry -- a lov item.
+ */
+BMLOVItem
+_bitmap_formitem(uint64 currTidNumber)
+{
+	int			nbytes_bmitem;
+	BMLOVItem	bmitem;
+
+	nbytes_bmitem = sizeof(BMLOVItemData);
+
+	bmitem = (BMLOVItem)palloc(nbytes_bmitem);
+
+	bmitem->bm_lov_head = bmitem->bm_lov_tail = InvalidBlockNumber;
+	bmitem->bm_last_setbit = 0;
+	bmitem->bm_last_two_headerbits = (1<<7);
+
+	/* fill up all existing bits with 0. */
+	if (currTidNumber < BM_HRL_WORD_SIZE)
+	{
+		bmitem->bm_last_compword = LITERAL_ALL_ONE;
+		bmitem->bm_last_word = LITERAL_ALL_ZERO;
+		bmitem->bm_last_two_headerbits = 0;
+		bmitem->bm_last_tid_location = 0;
+	}
+
+	else
+	{
+		uint32		numOfTotalFillWords;
+		BM_HRL_WORD	numOfFillWords;
+
+		numOfTotalFillWords = (currTidNumber-1)/BM_HRL_WORD_SIZE;
+
+		numOfFillWords =
+				(numOfTotalFillWords >= MAX_FILL_LENGTH) ? MAX_FILL_LENGTH :
+				numOfTotalFillWords;
+
+		bmitem->bm_last_compword = 
+			BM_MAKE_FILL_WORD (0, numOfFillWords);
+		bmitem->bm_last_word = LITERAL_ALL_ZERO;
+		bmitem->bm_last_two_headerbits = 2;
+
+		bmitem->bm_last_tid_location = numOfFillWords*BM_HRL_WORD_SIZE;
+
+		/*
+		 * If all zeros are too many to fit in one word, then
+		 * we set bm_last_setbit so that the remaining zeros can
+		 * be handled outside.
+		 */
+		if (numOfTotalFillWords > numOfFillWords)
+			bmitem->bm_last_setbit = numOfFillWords*BM_HRL_WORD_SIZE;
+	}
+
+	return bmitem;
+}
+
+/*
+ * _bitmap_init_batchwords() -- initialize a BMBatchWords in a given
+ * memory context.
+ *
+ * Allocate spaces for bitmap header words and bitmap content words.
+ */
+void
+_bitmap_init_batchwords(BMBatchWords* words,
+						uint32 maxNumOfWords,
+						MemoryContext mcxt)
+{
+	uint32	numOfHeaderWords;
+
+	words->numOfWordsRead = 0;
+	words->nextReadNo = 1;
+	words->startNo = 0;
+	words->numOfWords = 0;
+
+	numOfHeaderWords = 
+		maxNumOfWords/BM_HRL_WORD_SIZE +
+		((maxNumOfWords%BM_HRL_WORD_SIZE == 0) ? 0 : 1);
+
+	words->maxNumOfWords = maxNumOfWords;
+
+	/* Make sure that we have at least one page of words */
+	Assert(words->maxNumOfWords >= BM_NUM_OF_HRL_WORDS_PER_PAGE);
+
+	words->bitmapHeaderWords =
+		MemoryContextAllocZero(mcxt, 
+								sizeof(BM_HRL_WORD)*numOfHeaderWords);
+	words->bitmapContentWords = 
+		MemoryContextAllocZero(mcxt, 
+							   sizeof(BM_HRL_WORD)*words->maxNumOfWords);
+}
+
+/*
+ * _bitmap_reset_batchwords() -- reset the BMBatchWords for re-use.
+ */
+void
+_bitmap_reset_batchwords(BMBatchWords* words)
+{
+	words->startNo = 0;
+	words->numOfWords = 0;
+	memset (words->bitmapHeaderWords, 0,
+			(words->maxNumOfWords/BM_HRL_WORD_SIZE +
+			 ((words->maxNumOfWords%BM_HRL_WORD_SIZE == 0) ? 0 : 1)));
+}
+
+/*
+ * _bitmap_cleanup_batchwords() -- release spaces allocated for the BMBatchWords.
+ */
+void _bitmap_cleanup_batchwords(BMBatchWords* words)
+{
+	if (words == NULL)
+		return;
+
+	if (words->bitmapHeaderWords)
+		pfree(words->bitmapHeaderWords);
+	if (words->bitmapContentWords)
+		pfree(words->bitmapContentWords);
+}
+
+/*
+ * _bitmap_findnexttid() -- find the next tid location in a given batch
+ *  of bitmap words.
+ */
+uint64
+_bitmap_findnexttid(BMBatchWords *words,
+					BMIterateResult *result) {
+	/* if there is not tids from previous computation, then we
+	   try to find next set of tids. */
+	if (result->nextTidLoc >= result->numOfTids)
+		_bitmap_findnexttids(words, result, BM_BATCH_TIDS);
+
+	/* if find more tids, then return the first one */
+	if (result->nextTidLoc < result->numOfTids)
+	{
+		result->nextTidLoc++;
+		return (result->nextTids[result->nextTidLoc-1]);
+	}
+
+	/* no more tids */
+	return 0;
+}
+
+/*
+ * _bitmap_findnexttids() -- find the next set of tids from a given
+ *  batch of bitmap words.
+ *
+ * The maximum number of tids to be found is defined in 'maxTids'.
+ */
+void
+_bitmap_findnexttids(BMBatchWords *words,
+					 BMIterateResult *result,
+					 uint32 maxTids) {
+	bool done = false;
+
+	result->nextTidLoc = result->numOfTids = 0;
+	while (words->numOfWords > 0 &&
+		   result->numOfTids < maxTids && !done) {
+
+		uint8 oldScanPos = result->lastScanPos;
+		BM_HRL_WORD word = 
+			words->bitmapContentWords[result->lastScanWordNo];
+
+		/* if this is a new word, and a zero fill word */
+		if ((oldScanPos == 0) &&
+			((IS_FILL_WORD(words->bitmapHeaderWords, 
+						   result->lastScanWordNo) && 
+			(GET_FILL_BIT(word) == 0)) ||
+			(word == 0))) {
+			uint32	fillLength;
+			if (word == 0)
+				fillLength = 1;
+			else
+				fillLength = FILL_LENGTH(word);
+			result->nextTid +=
+				fillLength * BM_HRL_WORD_SIZE;
+
+			result->lastScanWordNo ++;
+			words->numOfWords --;
+			result->lastScanPos = 0;
+			continue;
+		}
+
+		/* if this is a set fill word */
+		else if (IS_FILL_WORD(words->bitmapHeaderWords, 
+							  result->lastScanWordNo) && 
+				 (GET_FILL_BIT(word) == 1)) {
+			uint32	numOfFillWords = FILL_LENGTH(word);
+			uint8 	bitNo;
+
+			while ((numOfFillWords > 0) && 
+				   (result->numOfTids+BM_HRL_WORD_SIZE <= maxTids)) {
+				for (bitNo=0; bitNo<BM_HRL_WORD_SIZE; bitNo++) {
+					result->nextTids[result->numOfTids++] =
+						(++result->nextTid);
+				}
+				numOfFillWords--;
+				words->bitmapContentWords[result->lastScanWordNo]--;
+			}
+
+			if (numOfFillWords == 0) {
+				result->lastScanWordNo++;
+				words->numOfWords--;
+				result->lastScanPos = 0;
+				continue;
+			} else {
+				done = true;
+				break;
+			}
+		}
+
+		if(oldScanPos == 0)
+			oldScanPos = BM_HRL_WORD_SIZE+1;
+
+		while (oldScanPos != 0 && result->numOfTids < maxTids) {
+			if (oldScanPos == BM_HRL_WORD_SIZE+1)
+				oldScanPos = 0;
+			result->lastScanPos =
+				_bitmap_find_bitset(
+					words->bitmapContentWords[result->lastScanWordNo],
+					oldScanPos);
+
+			/* if we found a set bit in this word. */
+			if (result->lastScanPos != 0)
+			{
+				result->nextTid += 
+					(result->lastScanPos - oldScanPos);
+				result->nextTids[result->numOfTids++] = result->nextTid;
+			}
+			else
+			{
+				result->nextTid +=
+					BM_HRL_WORD_SIZE - oldScanPos;
+
+				/* start scanning a new word */
+				words->numOfWords --;
+				result->lastScanWordNo ++;
+				result->lastScanPos = 0;
+			}
+
+			oldScanPos = result->lastScanPos;
+		}
+	}
+}
+
+/*
+ * _bitmap_intersect() -- intersect 'numBatches' bitmap words.
+ *
+ * All 'numBatches' bitmap words are HRL compressed. The result
+ * bitmap words HRL compressed, except that fill set words(1s) may
+ * be lossily compressed.
+ */
+void
+_bitmap_intersect(BMBatchWords **batches, uint32 numBatches,
+				  BMBatchWords *result) {
+	bool done = false;
+	uint32	*prevStartNos;
+	uint32	nextReadNo;
+	uint32	batchNo;
+
+	Assert(numBatches > 0);
+
+	prevStartNos = (uint32*)palloc0(numBatches*sizeof(uint32));
+
+	nextReadNo = batches[0]->nextReadNo;
+
+	while (!done &&
+			result->numOfWords < result->maxNumOfWords)
+	{
+		BM_HRL_WORD andWord = LITERAL_ALL_ONE;
+		BM_HRL_WORD	word;
+
+		bool		andWordIsLiteral = true;
+
+		/*
+    	 * We walk through the bitmap word in each list one by one
+         * without de-compress the bitmap words. 'nextReadNo' defines
+         * the position of the next word that should be read in an
+         * uncompressed format.
+         */
+		for (batchNo=0; batchNo<numBatches; batchNo++)
+		{
+			/* skip nextReadNo-numOfWordsRead-1 words */
+			_bitmap_findnextword(batches[batchNo], nextReadNo);
+
+			if ((batches[batchNo])->numOfWords == 0)
+			{
+				done = true;
+				break;
+			}
+
+			Assert((batches[batchNo])->numOfWordsRead == nextReadNo-1);
+
+			/* Here, startNo should point to the word to be read. */
+			word = (batches[batchNo])->bitmapContentWords
+					[(batches[batchNo])->startNo];
+
+			if (IS_FILL_WORD((batches[batchNo])->bitmapHeaderWords,
+							 (batches[batchNo])->startNo) &&
+				(GET_FILL_BIT(word) == 0))
+			{
+				(batches[batchNo])->numOfWordsRead +=
+					FILL_LENGTH(word);
+
+				andWord = BM_MAKE_FILL_WORD
+					(0, (batches[batchNo])->numOfWordsRead-nextReadNo+1);
+				andWordIsLiteral = false;
+
+				nextReadNo = (batches[batchNo])->numOfWordsRead+1;
+				(batches[batchNo])->startNo ++;
+				(batches[batchNo])->numOfWords --;
+				break;
+			}
+
+			else if (IS_FILL_WORD((batches[batchNo])->bitmapHeaderWords,
+								  (batches[batchNo])->startNo) &&
+					 (GET_FILL_BIT(word) == 1)) {
+				(batches[batchNo])->numOfWordsRead ++;
+
+				prevStartNos[batchNo] = (batches[batchNo])->startNo;
+
+				if (FILL_LENGTH(word) == 1)
+				{
+					(batches[batchNo])->startNo ++;
+					(batches[batchNo])->numOfWords --;
+				}
+
+				else {
+					(batches[batchNo])->bitmapContentWords
+					[(batches[batchNo])->startNo] -= 1;
+				}
+
+				andWordIsLiteral = true;
+			}
+
+			else if (!IS_FILL_WORD((batches[batchNo])->bitmapHeaderWords,
+									(batches[batchNo])->startNo))
+			{
+				prevStartNos[batchNo] = (batches[batchNo])->startNo;
+
+				andWord &= word;
+				(batches[batchNo])->numOfWordsRead ++;
+				(batches[batchNo])->startNo ++;
+				(batches[batchNo])->numOfWords --;
+
+				andWordIsLiteral = true;
+			}
+		}
+
+		/* Since there are not enough words in this attribute,
+			break this loop. */
+		if (done) {
+			uint32 preBatchNo;
+
+			/* reset the attributes before batchNo */
+			for (preBatchNo=0; preBatchNo<batchNo; preBatchNo++) {
+				_bitmap_resetWord(batches[preBatchNo], prevStartNos[preBatchNo]);
+			}
+
+			break;
+		}
+
+		if (!done) {
+			if (!andWordIsLiteral)
+				result->bitmapHeaderWords[
+					result->numOfWords/BM_HRL_WORD_SIZE] |=
+					(((BM_HRL_WORD)1)<<(BM_HRL_WORD_SIZE-1-
+					 (result->numOfWords%BM_HRL_WORD_SIZE)));
+			result->bitmapContentWords[result->numOfWords] =
+				andWord;
+			result->numOfWords++;
+		}
+
+		if (andWordIsLiteral)
+			nextReadNo++;
+
+		if (batchNo == 1 && 
+			(batches[batchNo])->numOfWords == 0)
+			done = true;
+	}
+
+	/* set the nextReadNo */
+	for (batchNo=0; batchNo<numBatches; batchNo++)
+		batches[batchNo]->nextReadNo = nextReadNo;
+
+	pfree(prevStartNos);
+}
+
+/*
+ * _bitmap_union() -- union 'numBatches' bitmap words.
+ *
+ * All 'numBatches' bitmap words are HRL compressed. The result
+ * bitmap words HRL compressed, except that fill unset words(0s) may
+ * be lossily compressed.
+ */
+void
+_bitmap_union(BMBatchWords **batches, uint32 numBatches,
+			  BMBatchWords *result) {
+	bool done = false;
+	uint32	*prevStartNos;
+	uint32	nextReadNo;
+	uint32		batchNo;
+
+	Assert (numBatches >= 0);
+
+	if (numBatches == 0)
+		return;
+
+	prevStartNos = (uint32*)palloc0(numBatches*sizeof(uint32));
+
+	nextReadNo = batches[0]->nextReadNo;
+
+	while (!done &&
+			result->numOfWords < result->maxNumOfWords)
+	{
+		BM_HRL_WORD orWord = LITERAL_ALL_ZERO;
+		BM_HRL_WORD	word;
+
+		bool		orWordIsLiteral = true;
+
+		for (batchNo=0; batchNo<numBatches; batchNo++)
+		{
+			/* skip nextReadNo-numOfWordsRead-1 words */
+			_bitmap_findnextword(batches[batchNo], nextReadNo);
+
+			if ((batches[batchNo])->numOfWords == 0)
+			{
+				done = true;
+				break;
+			}
+
+			Assert((batches[batchNo])->numOfWordsRead == nextReadNo-1);
+
+			/* Here, startNo should point to the word to be read. */
+			word = (batches[batchNo])->bitmapContentWords
+					[(batches[batchNo])->startNo];
+
+			if (IS_FILL_WORD((batches[batchNo])->bitmapHeaderWords,
+							 (batches[batchNo])->startNo) &&
+				(GET_FILL_BIT(word) == 1))
+			{
+				(batches[batchNo])->numOfWordsRead +=
+					FILL_LENGTH(word);
+
+				orWord = BM_MAKE_FILL_WORD
+					(1, (batches[batchNo])->numOfWordsRead-nextReadNo+1);
+				orWordIsLiteral = false;
+
+				nextReadNo = (batches[batchNo])->numOfWordsRead+1;
+				(batches[batchNo])->startNo ++;
+				(batches[batchNo])->numOfWords --;
+				break;
+			}
+
+			else if (IS_FILL_WORD((batches[batchNo])->bitmapHeaderWords,
+								  (batches[batchNo])->startNo) &&
+					 (GET_FILL_BIT(word) == 0)) {
+				(batches[batchNo])->numOfWordsRead ++;
+
+				prevStartNos[batchNo] = (batches[batchNo])->startNo;
+
+				if (FILL_LENGTH(word) == 1)
+				{
+					(batches[batchNo])->startNo ++;
+					(batches[batchNo])->numOfWords --;
+				}
+
+				else {
+					(batches[batchNo])->bitmapContentWords
+					[(batches[batchNo])->startNo] -= 1;
+				}
+
+				orWordIsLiteral = true;
+			}
+
+			else if (!IS_FILL_WORD((batches[batchNo])->bitmapHeaderWords,
+									(batches[batchNo])->startNo))
+			{
+				prevStartNos[batchNo] = (batches[batchNo])->startNo;
+
+				orWord |= word;
+				(batches[batchNo])->numOfWordsRead ++;
+				(batches[batchNo])->startNo ++;
+				(batches[batchNo])->numOfWords --;
+
+				orWordIsLiteral = true;
+			}
+		}
+
+		/* Since there are not enough words in this attribute,
+			break this loop. */
+		if (done) {
+			uint32 preBatchNo;
+
+			/* reset the attributes before batchNo */
+			for (preBatchNo=0; preBatchNo<batchNo; preBatchNo++) {
+				_bitmap_resetWord(batches[preBatchNo], prevStartNos[preBatchNo]);
+			}
+
+			break;
+		}
+
+		if (!done) {
+			if (!orWordIsLiteral)
+				result->bitmapHeaderWords[
+					result->numOfWords/BM_HRL_WORD_SIZE] |=
+					(((BM_HRL_WORD)1)<<(BM_HRL_WORD_SIZE-1-
+					 (result->numOfWords%BM_HRL_WORD_SIZE)));
+			result->bitmapContentWords[result->numOfWords] = orWord;
+			result->numOfWords++;
+		}
+
+		if (orWordIsLiteral)
+			nextReadNo++;
+
+		if (batchNo == numBatches-1 && 
+			(batches[batchNo])->numOfWords == 0)
+			done = true;
+	}
+
+	/* set the nextReadNo */
+	for (batchNo=0; batchNo<numBatches; batchNo++)
+		batches[batchNo]->nextReadNo = nextReadNo;
+
+	pfree(prevStartNos);
+}
+
+/*
+ * _bitmap_findnextword() -- Find the next word whose position is
+ *        	                'nextReadNo' in an uncompressed format.
+ */
+static void
+_bitmap_findnextword(BMBatchWords* words, uint32 nextReadNo)
+{
+	/* 
+     * 'words->numOfWordsRead' defines how many un-compressed words
+     * have been read in this OnDiskBitmapWords. We read from
+     * position 'startNo', and increment 'words->numOfWordsRead'
+     * differently based on the type of words that are read, until
+     * 'words->numOfWordsRead' is equal to 'nextReadNo'.
+     */
+	while ( (words->numOfWords > 0) &&
+			(words->numOfWordsRead < 
+			  nextReadNo-1))
+	{
+		BM_HRL_WORD word = words->bitmapContentWords
+				[words->startNo];
+
+		if (IS_FILL_WORD(words->bitmapHeaderWords,
+						 words->startNo)) {
+			if(FILL_LENGTH(word) <= 
+				(nextReadNo-
+				words->numOfWordsRead-1))
+			{
+				words->numOfWordsRead +=
+					FILL_LENGTH(word);
+				words->startNo ++;
+				words->numOfWords --;
+			}
+
+			else {
+				words->bitmapContentWords
+				[words->startNo] -=
+					(nextReadNo-
+					 words->numOfWordsRead-1);
+				words->numOfWordsRead = 
+					nextReadNo-1;
+			}
+		}
+		else {
+			words->numOfWordsRead ++;
+			words->startNo ++;
+			words->numOfWords --;
+		}
+	}
+}
+
+/*
+ * _bitmap_resetWord() -- Reset the read position in an BMBatchWords
+ *       	              to its previous value.
+ *
+ * Reset the read position in an BMBatchWords to its previous value,
+ * which is given in 'prevStartNo'. Based on different type of words read,
+ * the actual bitmap word may need to be changed.
+ */
+static void
+_bitmap_resetWord(BMBatchWords *words, uint32 prevStartNo)
+{
+	if (words->startNo > prevStartNo) {
+
+		Assert (words->startNo == prevStartNo + 1);
+
+		words->startNo = prevStartNo;
+		words->numOfWords++;
+	}
+
+	else {
+		Assert ((words->startNo == prevStartNo) && 
+				IS_FILL_WORD(words->bitmapHeaderWords, words->startNo));
+		words->bitmapContentWords[words->startNo] ++;
+	}
+
+	words->numOfWordsRead--;
+}
+
+/*
+ * _bitmap_find_bitset() -- find the leftmost set bit (bit=1) in the 
+ * 		given word since 'lastPos', not including 'lastPos'.
+ *
+ * The leftmost bit in the given word is considered the position 1, and
+ * the rightmost bit is considered the position BM_HRL_WORD_SIZE.
+ *
+ * If such set bit does not exist in this word, 0 is returned.
+ */
+static uint8
+_bitmap_find_bitset(BM_HRL_WORD word, uint8 lastPos)
+{
+	uint8 pos = lastPos+1;
+	BM_HRL_WORD	leftmostBitWord;
+
+	if (pos > BM_HRL_WORD_SIZE)
+	  return 0;
+
+	leftmostBitWord = (((BM_HRL_WORD)1) << (BM_HRL_WORD_SIZE - pos));
+
+	while ((pos<=BM_HRL_WORD_SIZE) &&
+		   ((word & leftmostBitWord) == 0))
+	{
+		leftmostBitWord >>= 1;
+		pos ++;
+	}
+
+	if (pos > BM_HRL_WORD_SIZE)
+		pos = 0;
+
+	return pos;
+}
+
+/*
+ * _bitmap_begin_iterate() -- initialize the given BMIterateResult instance.
+ */
+void
+_bitmap_begin_iterate(BMBatchWords *words, BMIterateResult* result)
+{
+	result->nextTid = words->firstTid;
+	result->lastScanPos = 0;
+	result->lastScanWordNo = words->startNo;
+	result->numOfTids = 0;
+	result->nextTidLoc = 0;
+}
+
+/*
+ * _bitmap_log_newpage() -- log a new page.
+ *
+ * This function is called before writing a new buffer. If metapage is not NULL,
+ * this function also logs the changes to the metapage.
+ */
+void
+_bitmap_log_newpage(Relation rel, uint8 info, Buffer buf, BMMetaPage metapage)
+{
+	Page page;
+
+	page = BufferGetPage(buf);
+
+	/* XLOG stuff */
+	START_CRIT_SECTION();
+
+	if (!(rel->rd_istemp))
+	{
+		xl_bm_newpage		xlNewPage;
+		XLogRecPtr			recptr;
+
+		xlNewPage.bm_node = rel->rd_node;
+		xlNewPage.bm_new_blkno = BufferGetBlockNumber(buf);
+
+		if (metapage != NULL)
+		{
+			XLogRecData			rdata[2];
+			xl_bm_metapage*		xlMeta = (xl_bm_metapage*)
+				palloc(MAXALIGN(sizeof(xl_bm_metapage)));
+
+			rdata[0].buffer = InvalidBuffer;
+			rdata[0].data = (char*)&xlNewPage;
+			rdata[0].len = sizeof(xl_bm_newpage);
+			rdata[0].next = &(rdata[1]);
+
+			xlMeta->bm_node = rel->rd_node;
+
+			rdata[1].buffer = InvalidBuffer;
+			rdata[1].data = (char*)xlMeta;
+			rdata[1].len = MAXALIGN(sizeof(xl_bm_metapage));
+			rdata[1].next = NULL;
+
+			recptr = XLogInsert(RM_BITMAP_ID, info, rdata);
+
+			PageSetLSN(page, recptr);
+			PageSetTLI(page, ThisTimeLineID);
+			PageSetLSN(metapage, recptr);
+			PageSetTLI(metapage, ThisTimeLineID);
+			pfree(xlMeta);
+		}
+
+		else 
+		{
+			XLogRecData			rdata[1];
+
+			rdata[0].buffer = InvalidBuffer;
+			rdata[0].data = (char*)&xlNewPage;
+			rdata[0].len = sizeof(xl_bm_newpage);
+			rdata[0].next = NULL;
+			
+			recptr = XLogInsert(RM_BITMAP_ID, info, rdata);
+
+			PageSetLSN(page, recptr);
+			PageSetTLI(page, ThisTimeLineID);
+
+			if (metapage != NULL)
+			{
+				PageSetLSN(metapage, recptr);
+				PageSetTLI(metapage, ThisTimeLineID);
+			}
+		}
+
+	}
+
+	END_CRIT_SECTION();
+}
+
+/*
+ * _bitmap_log_metapage() -- log the changes to the metapage
+ */
+void
+_bitmap_log_metapage(Relation rel, BMMetaPage metapage)
+{
+	/* XLOG stuff */
+	START_CRIT_SECTION();
+
+	if (!(rel->rd_istemp))
+	{
+		xl_bm_metapage*		xlMeta;
+		XLogRecPtr			recptr;
+		XLogRecData			rdata[1];
+
+		xlMeta = (xl_bm_metapage*)
+			palloc(MAXALIGN(sizeof(xl_bm_metapage)));
+		xlMeta->bm_node = rel->rd_node;
+		xlMeta->bm_num_tuples = metapage->bm_num_tuples;
+		xlMeta->bm_lov_heapId = metapage->bm_lov_heapId;
+		xlMeta->bm_lov_indexId = metapage->bm_lov_indexId;
+		xlMeta->bm_lov_lastpage = metapage->bm_lov_lastpage;
+		xlMeta->bm_need_rebuilt = metapage->bm_need_rebuilt;
+
+		rdata[0].buffer = InvalidBuffer;
+		rdata[0].data = (char*)xlMeta;
+		rdata[0].len = MAXALIGN(sizeof(xl_bm_metapage));
+		rdata[0].next = NULL;
+			
+		recptr = XLogInsert(RM_BITMAP_ID, XLOG_BITMAP_INSERT_META, rdata);
+
+		PageSetLSN(metapage, recptr);
+		PageSetTLI(metapage, ThisTimeLineID);
+		pfree(xlMeta);
+	}
+
+	END_CRIT_SECTION();
+}
+
+/*
+ * _bitmap_log_bitmappage() -- log the changes to a bitmap page.
+ *
+ * This function inserts the changes to a bitmap page to xlog.
+ * The parameter 'numWords' defines the last 'numWords' words
+ * in bitmapBuffer are new. If isOpaque is set, then we also
+ * log the information about the block number for the next
+ * bitmap page.
+ */
+void
+_bitmap_log_bitmappage(Relation rel, Buffer bitmapBuffer, bool isOpaque,
+					   uint32 numWords)
+{
+	Page			bitmapPage;
+	BMBitmapOpaque	bitmapPageOpaque;
+	BMBitmap		bitmap;
+
+	bitmapPage = BufferGetPage(bitmapBuffer);
+	bitmapPageOpaque = (BMBitmapOpaque)PageGetSpecialPointer(bitmapPage);
+	bitmap = (BMBitmap) PageGetContents(bitmapPage);
+
+	Assert(bitmapPageOpaque->bm_hrl_words_used >= numWords);
+
+	/* XLOG stuff */
+	START_CRIT_SECTION();
+
+	if (!(rel->rd_istemp))
+	{
+		xl_bm_bitmappage*	xlBitmap;
+		XLogRecPtr			recptr;
+		XLogRecData			rdata[1];
+		BM_HRL_WORD*		bitmapWords;
+
+		xlBitmap = (xl_bm_bitmappage*)
+			palloc(MAXALIGN(sizeof(xl_bm_bitmappage)) +
+					numWords*sizeof(BM_HRL_WORD));
+		xlBitmap->bm_node = rel->rd_node;
+		xlBitmap->bm_bitmap_blkno = BufferGetBlockNumber(bitmapBuffer);
+		xlBitmap->bm_isOpaque = isOpaque;
+
+		xlBitmap->bm_last_tid_location = bitmapPageOpaque->bm_last_tid_location;
+		xlBitmap->bm_hrl_words_used = bitmapPageOpaque->bm_hrl_words_used;
+		bitmapWords = (BM_HRL_WORD*)
+			(((char*)xlBitmap) + MAXALIGN(sizeof(xl_bm_bitmappage)));
+		xlBitmap->bm_num_words = numWords;
+		memcpy(xlBitmap->bm_headerWords,
+			   bitmap->bm_headerWords, 
+			   BM_MAX_NUM_OF_HEADER_WORDS*sizeof(BM_HRL_WORD));
+		memcpy(bitmapWords,
+			   (bitmap->bm_contentWords + (bitmapPageOpaque->bm_hrl_words_used - 
+				numWords)),
+			   numWords*sizeof(BM_HRL_WORD));
+		xlBitmap->bm_next_blkno = InvalidBlockNumber;
+
+		if (isOpaque)
+			xlBitmap->bm_next_blkno = bitmapPageOpaque->bm_bitmap_next;
+
+		rdata[0].buffer = InvalidBuffer;
+		rdata[0].data = (char*)xlBitmap;
+		rdata[0].len = MAXALIGN(sizeof(xl_bm_bitmappage)) + 
+						numWords*sizeof(BM_HRL_WORD);
+		rdata[0].next = NULL;
+
+		recptr = XLogInsert(RM_BITMAP_ID, XLOG_BITMAP_INSERT_BITMAP, rdata);
+
+		PageSetLSN(bitmapPage, recptr);
+		PageSetTLI(bitmapPage, ThisTimeLineID);
+		pfree(xlBitmap);
+	}	
+
+	END_CRIT_SECTION();
+}
+
+/*
+ * _bitmap_log_bitmap_lastwords() -- log the last two words in a bitmap.
+ */
+void
+_bitmap_log_bitmap_lastwords(Relation rel, Buffer lovBuffer, 
+							 OffsetNumber lovOffset, BMLOVItem lovItem)
+{
+	/* XLOG stuff */
+	START_CRIT_SECTION();
+
+	if (!(rel->rd_istemp))
+	{
+		xl_bm_bitmap_lastwords	xlLastwords;
+		XLogRecPtr				recptr;
+		XLogRecData				rdata[1];
+
+		xlLastwords.bm_node = rel->rd_node;
+		xlLastwords.bm_last_compword = lovItem->bm_last_compword;
+		xlLastwords.bm_last_word = lovItem->bm_last_word;
+		xlLastwords.bm_last_two_headerbits = lovItem->bm_last_two_headerbits;
+		xlLastwords.bm_lov_blkno = BufferGetBlockNumber(lovBuffer);
+		xlLastwords.bm_lov_offset = lovOffset;
+
+		rdata[0].buffer = InvalidBuffer;
+		rdata[0].data = (char*)&xlLastwords;
+		rdata[0].len = sizeof(xl_bm_bitmap_lastwords);
+		rdata[0].next = NULL;
+
+		recptr = 
+			XLogInsert(RM_BITMAP_ID, XLOG_BITMAP_INSERT_BITMAP_LASTWORDS, rdata);
+
+		PageSetLSN(BufferGetPage(lovBuffer), recptr);
+		PageSetTLI(BufferGetPage(lovBuffer), ThisTimeLineID);
+	}
+
+	END_CRIT_SECTION();
+}
+
+/*
+ * _bitmap_log_lovitem() -- log adding a new lov item to a lov page.
+ */
+void
+_bitmap_log_lovitem(Relation rel, Buffer lovBuffer, bool isNewItem,
+					OffsetNumber offset, BMLOVItem lovItem)
+{
+	Page lovPage = BufferGetPage(lovBuffer);
+
+	/* XLOG stuff */
+	START_CRIT_SECTION();
+
+	if (!(rel->rd_istemp))
+	{
+		xl_bm_lovitem	xlLovItem;
+		XLogRecPtr		recptr;
+		XLogRecData		rdata[1];
+
+		xlLovItem.bm_node = rel->rd_node;
+		xlLovItem.bm_lov_blkno = BufferGetBlockNumber(lovBuffer);
+		xlLovItem.bm_isNewItem = isNewItem;
+		xlLovItem.bm_lov_offset = offset;
+		memcpy(&(xlLovItem.bm_lovItem), lovItem,
+				sizeof(BMLOVItemData));
+
+		rdata[0].buffer = InvalidBuffer;
+		rdata[0].data = (char*)&xlLovItem;
+		rdata[0].len = sizeof(xl_bm_lovitem);
+		rdata[0].next = NULL;
+
+		recptr = XLogInsert(RM_BITMAP_ID, 
+							XLOG_BITMAP_INSERT_LOVITEM, rdata);
+
+		PageSetLSN(lovPage, recptr);
+		PageSetTLI(lovPage, ThisTimeLineID);
+	}
+
+	END_CRIT_SECTION();
+}
+
+Datum
+bmoptions(PG_FUNCTION_ARGS)
+{
+	Datum		reloptions = PG_GETARG_DATUM(0);
+	bool		validate = PG_GETARG_BOOL(1);
+	bytea	   *result;
+
+	/*
+	 * It's not clear that fillfactor is useful for on-disk bitmap index,
+	 * but for the moment we'll accept it anyway.  (It won't do anything...)
+	 */
+#define GIN_MIN_FILLFACTOR			10
+#define GIN_DEFAULT_FILLFACTOR		100
+
+	result = default_reloptions(reloptions, validate,
+								GIN_MIN_FILLFACTOR,
+								GIN_DEFAULT_FILLFACTOR);
+	if (result)
+		PG_RETURN_BYTEA_P(result);
+	PG_RETURN_NULL();
+}
